{% extends "base.html" %}
{% load static %}
{% load i18n %}

{% block styles %}
    <style>
        .separator {
            position: relative;
            margin: 2rem 0;
            border-top: 1px solid #dee2e6;
        }

        .separator > .separator-label {
            position: absolute;
            background: var(--white);
            color: #6c757d;
            top: -.9rem;
            left: 50%;
            transform: translate(-50%);
            padding: 0 .5em;
            font-size: 1rem;
        }
    </style>
{% endblock %}

{% block scripts %}
    <script>
        window.addEventListener("load", function () {
            const form = document.getElementById("username_submit_form");
            form.addEventListener("submit", function (event) {
                event.preventDefault();
                event.stopPropagation();

                form.classList.add("was-validated");
                if (form.checkValidity() === true) {
                    const formData = new FormData();
                    formData.append("username", document.getElementById("join_username").value.trim());
                    formData.append("csrfmiddlewaretoken", "{{ csrf_token }}");

                    fetch("{% url "session_set_username" %}", {
                        method: "POST",
                        body: formData,
                    }).then(function (response) {
                        if (response.ok) {
                            location.reload();
                        } else {
                            console.error(response);
                        }
                    }).catch(function (error) {
                        console.error(error);
                    });
                }
            });
        });
    </script>
{% endblock %}

{% block content %}
    <!-- No password / Only Username required -->
    <div class="col-md-6 offset-md-3">
        <div class="card">
            <h3 class="card-header text-center">
                {% with room.name|escape as room_name %}
                    {% blocktranslate with room_name_strong="<strong>"|add:room_name|add:"</strong>" %}
                        Join {{ room_name_strong }}
                    {% endblocktranslate %}
                {% endwith %}
            </h3>

            <div class="card-body">
                <form id="username_submit_form" class="needs-validation" novalidate>
                    <div class="form-group">
                        <label for="join_username">{% translate "Username" %}</label>
                        <div class="input-group">
                            <input id="join_username" type="text" class="form-control rounded-left" name="username"
                                   {# pattern => at least two non withespace characters #}
                                   placeholder="{% translate "Username" %}" required pattern="^.*\S.*\S.*$">
                            <div class="input-group-append">
                                <button type="submit" class="btn btn-secondary rounded-right">
                                    <em class="fas fa-arrow-right"></em>
                                </button>
                            </div>
                            <div class="invalid-feedback">
                                {% translate "Username is to short. Please Enter a longer username." %}
                            </div>
                        </div>
                        <div class="form-text text-muted">
                            {% translate "Please enter your name to join the room." %}
                        </div>
                    </div>
                    <div class="separator">
                        <div class="separator-label">{% translate "or" %}</div>
                    </div>
                    <div class="text-center">
                        <a href="{% url 'login' %}?next={% url 'join_or_create_meeting' meeting_id %}"
                           class="btn btn-primary">Login</a>
                    </div>
                </form>
            </div>
        </div>
    </div>
{% endblock %}
